#include "GameWindow.h"
#include "Constants.h"

GameWindow::GameWindow(BRect bounds)
  :BWindow(bounds,"Trench!", B_TITLED_WINDOW, B_NOT_ZOOMABLE | B_NOT_RESIZABLE)
{
//MENU STUFF
  bounds.Set(0,0,WINDOW_WIDTH,MENU_HEIGHT);
  fmbr_Menu = new BMenuBar(bounds, "Menu Bar");
  AddChild(fmbr_Menu);
  
  fmnu_Game = new BMenu("Game");
  fmbr_Menu->AddItem(fmnu_Game);
  
  fmnu_Game->AddItem(new BMenuItem("New Set", new BMessage(MSG_NEWSET)));
  fmnu_Game->AddItem(new BMenuItem("New Game", new BMessage(MSG_NEWGAME),'N'));
  fmnu_Game->AddItem(new BMenuItem("Show Scores", new BMessage(MSG_SHOWSCORES),'S'));
  fmnu_Game->AddSeparatorItem();
  fmnu_Game->AddItem(new BMenuItem("Quit", new BMessage(MSG_QUIT),'Q'));
  
  fmnu_Help = new BMenu("Help");
  fmbr_Menu->AddItem(fmnu_Help);
  
  fmnu_Help->AddItem(new BMenuItem("I'm in pain!!", new BMessage(MSG_HELPME), 'H'));
  fmnu_Help->AddItem(new BMenuItem("The Story", new BMessage(MSG_STORY)));
  fmnu_Help->AddItem(new BMenuItem("About Trench!", new BMessage(MSG_ABOUT)));

//END MENU STUFF  

//Window-relative coordinates for the onscreen view
  bounds.Set(0,MENU_HEIGHT + 5,WINDOW_WIDTH,WINDOW_HEIGHT);
  fpic_Main = new GameView(bounds);
  AddChild(fpic_Main);
  
//Absolute coordinates for the drawing view and the store BBitmap
  bounds.Set(0,0,WINDOW_WIDTH,WINDOW_HEIGHT - MENU_HEIGHT - 5);
  fpic_Draw = new BView(bounds,"Draw View",B_FOLLOW_ALL_SIDES,0);
  fbmp_Game = new GameBitmap(bounds, B_CMAP8, true);
  fbmp_Game->AddChild(fpic_Draw);

 
  SetPulseRate(STOPPED_RATE);
};

GameWindow::~GameWindow()
{
  fbmp_Game->RemoveChild(fpic_Draw);
  delete fpic_Draw;
  delete fbmp_Game;

  RemoveChild(fpic_Main);
  delete fpic_Main;
};

void GameWindow::WindowActivated(bool active)
{
  if (active)
  {
    fpic_Main->MakeFocus();
  };
};

bool GameWindow::QuitRequested()
{
  be_app->PostMessage(B_QUIT_REQUESTED);	//tell the app to quit.

  return true;								//yes, proceed.
};