//physics.h -- this file determines the physics of the system.

#ifndef TRENCH_PHYSICS_H
#define TRENCH_PHYSICS_H

#include <InterfaceKit.h>				//this is for the BPoint implementation
#include <stdlib.h>						//this is for randomization.
#include <time.h>						//this is for random seeds.
#include "Constants.h"					//cool constants.

typedef int cardinal;

class player
{
  public:
    inline player();
    
    void				setup();				//sets up the player.
       
    inline void			advance();			//moves it one in the direction
    inline void			turn(bool left);	//turns to the right or left.
    inline bool			alive();			//is he alive?
    inline void			kill();				//kill the player.
    inline void			setmine();			//sets the mine.
    inline bool			mined();			//tells if mine not detonated.
    inline BPoint		getmine();			//tells where the mine is.
  
    BPoint				location;
    bool				tokill;				//is it to be killed?

//General, changeable properties of the player
    rgb_color			drawcolor;			//the drawing color.
    char				*name;				//player's name.
    bool				human;				//human or AI?
    char				LTKey, RTKey, MNKey, JPKey;
        
  private:
    cardinal			direction;			//direction of the player
    BPoint				mine;				//secret location of mine.
    bool				minestate;			//is the mine set or not?
};

inline player::player()
{
  setup();
};

void player::setup()
{
  minestate = false;
  location.x = (rand() % FIELD_WIDTH) + FIELD_LIMIT;
  location.y = (rand() % FIELD_HEIGHT) + FIELD_LIMIT;
  direction = (random() % 4) + 1;
};

BPoint ei(1,0);
BPoint ej(0,1);

inline void player::advance()
{
  switch (direction)
  {
    case UP:
      location -= ej;
    break;
    case DN:
      location += ej;
    break;
    case LT:
      location -= ei;
    break;
    case RT:
      location += ei;
    break;
  };
};

inline void player::turn(bool left)
{
  if (left)
    direction++;
  else
    direction--;
  
  switch (direction)
  {
    case UNDERLAP:
      direction = RT;
    break;
    case OVERLAP:
      direction = UP;
    break;
  };
};

inline bool player::alive()
{
  return (direction != DEAD);
};

inline void player::kill()
{
  direction = DEAD;
  tokill = false;
};

inline void player::setmine()
{
  mine = location;
  minestate = true;
};

inline bool player::mined()
{
  return minestate;
};

inline BPoint player::getmine()
{
  return mine;
  minestate = false;
};

#endif