#include "Trench.h"
#include "Constants.h"

//=============================================================
//member functions for the "Trench" class.

Trench::Trench()
  :BApplication("application/x-vnd.NoNameSoft-Trench")
  			//calls the BApplication constructor and provides
  			//a MIME-callsign for the application.
{
  BRect WindowSpecs(CORNER_LEFT,CORNER_TOP,CORNER_LEFT + WINDOW_WIDTH,CORNER_TOP + WINDOW_HEIGHT);
  
  ffrm_GameWindow = new GameWindow(WindowSpecs);	//allocate GameWindow.
  
  ffrm_GameWindow->Show();							//show it.
  
  ffrm_NewSet = new NewSetWindow;
};

void Trench::MessageReceived(BMessage *message)
{
  switch (message->what)
  {
    case MSG_IMPORT:
      ffrm_NewSet->Import();
    break;
    default:
      BApplication::MessageReceived(message);
  }
};

//=============================================================
//main procedure:  called by the system, it allocates and then
//invokes the program

int main()
{
  Trench *TrenchGame;			//set aside a pointer
  
  TrenchGame = new Trench;		//allocate the program memory
  
  TrenchGame->Run();			//run the game
  
  delete TrenchGame;  			//deallocate the memory.
};